﻿namespace KeydDI
{
    public interface INotificationService
    {
        void Notify(string message);
    }

    class SmsNotification : INotificationService
    {
        public void Notify(string message)
        {
            Console.WriteLine($"SMS: {message}");
        }
    }

    class EmailNotification : INotificationService
    {
        public void Notify(string message)
        {
            Console.WriteLine($"e-mail: {message}");
        }
    }

    class PushNotification : INotificationService
    {
        public void Notify(string message)
        {
            Console.WriteLine($"push: {message}");
        }
    }
}
