﻿using System;
using Microsoft.Extensions.DependencyInjection;

namespace KeydDI
{
    class Program
    {
        public static void Main(string[] args) 
        {
            Start.Przykład();
            return;

            //===============================================

            string kluczSms = "KluczSms";
            string kluczEmail = "KluczEmail";
            string kluczPush = "KluczPush";

            //tworzenie kolekcji (słownika z kluczami) usług
            IServiceProvider serviceProvider = new ServiceCollection()
                .AddKeyedSingleton<INotificationService, SmsNotification>(kluczSms) //kluczem może być dowolny obiekt, nie tylko łańcuch
                .AddKeyedSingleton<INotificationService, EmailNotification>(kluczEmail)
                .AddKeyedSingleton<INotificationService, PushNotification>(kluczPush)
                .BuildServiceProvider();

            //wybór usługi
            INotificationService smsService = serviceProvider.GetRequiredKeyedService<INotificationService>(kluczSms);
            INotificationService emailService = serviceProvider.GetRequiredKeyedService<INotificationService>(kluczEmail);
            INotificationService pushService = serviceProvider.GetRequiredKeyedService<INotificationService>(kluczPush);

            smsService.Notify("komunikat");
            emailService.Notify("komunikat");
            pushService.Notify("komunikat");
        }
    }
}